package com.thousandthoughts.tutorials;

import android.content.Context;
import android.graphics.Canvas;
import android.graphics.Color;
import android.graphics.Paint;
import android.graphics.Paint.Style;
//import android.util.Log;
import android.view.View;

public class CustomDrawableView  extends View{
	
	Paint paint = new Paint(Paint.ANTI_ALIAS_FLAG);
	int centerx, centery;
	int textYStep;
	float myAccMagValue = 0; 
	float myGyroValue = 0;
	float myFusedValue = 0;
	float myOrientValue = 0;
	
	public CustomDrawableView(Context context) {
		super(context);
		paint.setColor(0xff00ff00);
		paint.setStyle(Style.STROKE);
		paint.setStrokeWidth(2);
		paint.setAntiAlias(true);
		paint.setStyle(Paint.Style.FILL);
	};

	private void myDraw(Canvas canvas, int color, float angle, int mul){
		// Rotate the canvas with the angle
		canvas.rotate( -angle, centerx, centery);
		paint.setColor(color);
		canvas.drawLine(centerx, -1000, centerx, +1000, paint);
		canvas.drawLine(-1000, centery, 1000, centery, paint);
		canvas.drawText("N", centerx + mul*textYStep, centery / 2, paint);
		canvas.drawText("S", (float) (centerx - mul*textYStep * 1.5) , centery * 3 / 2, paint);
		canvas.rotate( angle, centerx, centery);
	}
	
	@Override
	protected void onDraw(Canvas canvas) {
		centerx = getWidth() / 2;
		centery = getHeight() / 2;
		textYStep = Math.max(12, 12 * getHeight() / 400);

		paint.setTextSize(textYStep);
		paint.setColor(0xff00ff00);
		canvas.drawLine(centerx, 0, centerx, getHeight(), paint);
		canvas.drawLine(0, centery, getWidth(), centery, paint);

		paint.setStrokeWidth(2);
		myDraw(canvas, Color.YELLOW, (float) Math.toDegrees(myAccMagValue),0);
		myDraw(canvas, Color.CYAN, (float) Math.toDegrees(myGyroValue),1);
		myDraw(canvas, Color.WHITE, (float) Math.toDegrees(myFusedValue),2);
		myDraw(canvas, Color.RED, (float) Math.toDegrees(myOrientValue),3);
	}
	
	
	public void update(float accMagValue, float gyroValue, float fusedValue, float orientValue){
		//Log.v("View","updateOreintationDisplay " + accMagO + " " + gyroO + " " + fusedO);
		myAccMagValue = accMagValue; 
		myGyroValue = gyroValue;
		myFusedValue = fusedValue;
		myOrientValue = orientValue;
		invalidate();
	}

}
